﻿using SushiBarContracts.BindingModels;
using SushiBarContracts.ViewModels;
using SushiBarDataModels.Models;

namespace SushibarListImplement.Models
{
    public class Store : IStoreModel
    {
        public string StoreName { get; private set; } = string.Empty;
        public string StoreAdress { get; private set; } = string.Empty;
        public DateTime OpeningDate { get; private set; }
        public Dictionary<int, (ISushiModel, int)> Sushis { get; private set; } = new();
        public int Id { get; private set; }

        public static Store? Create(StoreBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Store()
            {
                Id = model.Id,
                StoreName = model.StoreName,
                StoreAdress = model.StoreAdress,
                OpeningDate = model.OpeningDate,
                Sushis = new()
            };
        }

        public void Update(StoreBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            StoreName = model.StoreName;
            StoreAdress = model.StoreAdress;
            OpeningDate = model.OpeningDate;
            Sushis = model.Sushis;
        }

        public StoreViewModel GetViewModel => new()
        {
            Id = Id,
            StoreName = StoreName,
            StoreAdress = StoreAdress,
            OpeningDate = OpeningDate,
            Sushis = Sushis
        };
    }
}
